// **********************************************************************************************
//
// world control functions
//
// **********************************************************************************************

API(NewtonCreate, newton)
API(NewtonDestroy, newton)
API(NewtonDestroyAllBodies, newton)
API(NewtonGetMemoryUsed, newton)

API(NewtonUpdate, newton)
API(NewtonInvalidateCache, newton)
API(NewtonCollisionUpdate, newton)

API(NewtonSetSolverModel, newton)
API(NewtonSetPlatformArchitecture, newton)
API(NewtonGetPlatformArchitecture, newton)
API(NewtonSetMultiThreadSolverOnSingleIsland, newton)

API(NewtonSetPerformanceClock, newton)
API(NewtonReadPerformanceTicks, newton)

API(NewtonWorldCriticalSectionLock, newton)
API(NewtonWorldCriticalSectionUnlock, newton)
API(NewtonSetThreadsCount, newton)
API(NewtonGetThreadsCount, newton)

API(NewtonSetFrictionModel, newton)
API(NewtonSetMinimumFrameRate, newton)
API(NewtonSetBodyLeaveWorldEvent, newton)
API(NewtonSetWorldSize, newton)
API(NewtonSetWorldSize, newton)

API(NewtonWorldForEachJointDo, newton)
API(NewtonWorldForEachBodyInAABBDo, newton)

API(NewtonWorldSetUserData, newton)
API(NewtonWorldGetUserData, newton)
API(NewtonWorldGetVersion, newton)
API(NewtonWorldRayCast, newton)
API(NewtonWorldConvexCast, newton)



API(NewtonWorldGetBodyCount, newton)
API(NewtonWorldGetConstraintCount, newton)

// **********************************************************************************************
//
// Simulation islands 
//
// **********************************************************************************************
API(NewtonIslandGetBody, newton)
API(NewtonIslandGetBodyAABB, newton)

// **********************************************************************************************
//
// Physics Material Section
//
// **********************************************************************************************
API(NewtonMaterialCreateGroupID, newton)
API(NewtonMaterialGetDefaultGroupID, newton)
API(NewtonMaterialDestroyAllGroupID, newton)

API(NewtonMaterialGetUserData, newton)
API(NewtonMaterialSetSurfaceThickness, newton)
API(NewtonMaterialSetContinuousCollisionMode, newton)
API(NewtonMaterialSetCollisionCallback, newton)

API(NewtonMaterialSetDefaultSoftness, newton)
API(NewtonMaterialSetDefaultElasticity, newton)
API(NewtonMaterialSetDefaultCollidable, newton)
API(NewtonMaterialSetDefaultFriction, newton)

API(NewtonWorldGetFirstMaterial, newton)
API(NewtonWorldGetNextMaterial, newton)

API(NewtonWorldGetFirstBody, newton)
API(NewtonWorldGetNextBody, newton)

// **********************************************************************************************
//
// Physics Contact control functions
//
// **********************************************************************************************
API(NewtonMaterialGetMaterialPairUserData, newton)
API(NewtonMaterialGetContactFaceAttribute, newton)
API(NewtonMaterialGetBodyCollisionID, newton)
API(NewtonMaterialGetContactNormalSpeed, newton)
API(NewtonMaterialGetContactForce, newton)
API(NewtonMaterialGetContactPositionAndNormal, newton)
API(NewtonMaterialGetContactTangentDirections, newton)
API(NewtonMaterialGetContactTangentSpeed, newton)

API(NewtonMaterialSetContactSoftness, newton)
API(NewtonMaterialSetContactElasticity, newton)
API(NewtonMaterialSetContactFrictionState, newton)
API(NewtonMaterialSetContactFrictionCoef, newton)

API(NewtonMaterialSetContactNormalAcceleration, newton)
API(NewtonMaterialSetContactNormalDirection, newton)

API(NewtonMaterialSetContactTangentAcceleration, newton)
API(NewtonMaterialContactRotateTangentDirections, newton)

// **********************************************************************************************
//
// convex collision primitives creation functions
//
// **********************************************************************************************
API(NewtonCreateNull, newton)
API(NewtonCreateSphere, newton)
API(NewtonCreateBox, newton)
API(NewtonMaterialContactRotateTangentDirections, newton)
API(NewtonCreateCone, newton)
API(NewtonCreateCapsule, newton)
API(NewtonCreateCylinder, newton)
API(NewtonCreateChamferCylinder, newton)
API(NewtonCreateConvexHull, newton)
API(NewtonCreateConvexHullFromMesh, newton)

API(NewtonCreateConvexHullModifier, newton)
API(NewtonConvexHullModifierGetMatrix, newton)
API(NewtonConvexHullModifierSetMatrix, newton)

API(NewtonCollisionIsTriggerVolume, newton)
API(NewtonCollisionSetAsTriggerVolume, newton)
API(NewtonConvexCollisionSetUserID, newton)
API(NewtonConvexCollisionGetUserID, newton)

API(NewtonConvexCollisionCalculateVolume, newton)
API(NewtonConvexCollisionCalculateInertialMatrix, newton)



API(NewtonCollisionMakeUnique, newton)
API(NewtonReleaseCollision, newton)
API(NewtonAddCollisionReference, newton)

// **********************************************************************************************
//
// complex collision primitives creation functions
//
// **********************************************************************************************
API(NewtonCreateCompoundCollision, newton)
API(NewtonCreateCompoundCollisionFromMesh, newton)

API(NewtonCreateUserMeshCollision, newton)

API(NewtonCreateSceneCollision, newton)
API(NewtonSceneCollisionCreateProxy, newton)
API(NewtonSceneCollisionDestroyProxy, newton)
API(NewtonSceneProxySetMatrix, newton)
API(NewtonSceneProxyGetMatrix, newton)

//  ***********************************************************************************************************
//
//	Collision serialization functions
//
// ***********************************************************************************************************
API(NewtonCreateCollisionFromSerialization, newton)
API(NewtonCollisionSerialize, newton)
API(NewtonCollisionGetInfo, newton)

// **********************************************************************************************
//
// Static collision shapes functions
//
// **********************************************************************************************
API(NewtonCreateHeightFieldCollision, newton)



API(NewtonCreateTreeCollision, newton)
API(NewtonTreeCollisionSetUserRayCastCallback, newton)

API(NewtonTreeCollisionBeginBuild, newton)
API(NewtonTreeCollisionAddFace, newton)
API(NewtonTreeCollisionEndBuild, newton)

API(NewtonTreeCollisionGetFaceAtribute, newton)
API(NewtonTreeCollisionSetFaceAtribute, newton)
API(NewtonTreeCollisionGetVertexListIndexListInAABB, newton)


API(NewtonStaticCollisionSetDebugCallback, newton)

// **********************************************************************************************
//
// General purpose collision library functions
//
// **********************************************************************************************
API(NewtonCollisionPointDistance, newton)
API(NewtonCollisionClosestPoint, newton)
API(NewtonCollisionCollide, newton)
API(NewtonCollisionCollideContinue, newton)

API(NewtonCollisionSupportVertex, newton)
API(NewtonCollisionRayCast, newton)
API(NewtonCollisionCalculateAABB, newton)
API(NewtonCollisionForEachPolygonDo, newton)

// **********************************************************************************************
//
// transforms utility functions
//
// **********************************************************************************************
API(NewtonGetEulerAngle, newton)
API(NewtonSetEulerAngle, newton)
API(NewtonCalculateSpringDamperAcceleration, newton)

// **********************************************************************************************
//
// body manipulation functions
//
// **********************************************************************************************
API(NewtonCreateBody, newton)
API(NewtonDestroyBody, newton)

API(NewtonBodyAddForce, newton)
API(NewtonBodyAddTorque, newton)
API(NewtonBodyCalculateInverseDynamicsForce, newton)

API(NewtonBodySetMatrix, newton)
API(NewtonBodySetMatrixRecursive, newton)
API(NewtonBodySetMassMatrix, newton)
API(NewtonBodySetMaterialGroupID, newton)
API(NewtonBodySetContinuousCollisionMode, newton)
API(NewtonBodySetJointRecursiveCollision, newton)
API(NewtonBodySetOmega, newton)
API(NewtonBodySetVelocity, newton)
API(NewtonBodySetForce, newton)
API(NewtonBodySetTorque, newton)

API(NewtonBodySetCentreOfMass, newton)
API(NewtonBodySetLinearDamping, newton)
API(NewtonBodySetAngularDamping, newton)
API(NewtonBodySetUserData, newton)
API(NewtonBodySetCollision, newton)

API(NewtonBodyGetSleepState, newton)
API(NewtonBodyGetAutoSleep, newton)
API(NewtonBodySetAutoSleep, newton)

API(NewtonBodyGetFreezeState, newton)
API(NewtonBodySetFreezeState, newton)

API(NewtonBodySetTransformCallback, newton)
API(NewtonBodySetDestructorCallback, newton)

API(NewtonBodySetForceAndTorqueCallback, newton)
API(NewtonBodyGetForceAndTorqueCallback, newton)
API(NewtonBodyGetUserData, newton)
API(NewtonBodyGetWorld, newton)
API(NewtonBodyGetCollision, newton)
API(NewtonBodyGetMaterialGroupID, newton)

API(NewtonBodyGetContinuousCollisionMode, newton)
API(NewtonBodyGetJointRecursiveCollision, newton)


API(NewtonBodyGetMatrix, newton)
API(NewtonBodyGetRotation, newton)
API(NewtonBodyGetMassMatrix, newton)
API(NewtonBodyGetInvMass, newton)
API(NewtonBodyGetOmega, newton)
API(NewtonBodyGetVelocity, newton)
API(NewtonBodyGetForce, newton)
API(NewtonBodyGetTorque, newton)
API(NewtonBodyGetUserData, newton)
API(NewtonBodyGetForceAcc, newton)
API(NewtonBodyGetTorqueAcc, newton)
API(NewtonBodyGetCentreOfMass, newton)

API(NewtonBodyGetLinearDamping, newton)
API(NewtonBodyGetAngularDamping, newton)
API(NewtonBodyGetAABB, newton)
API(NewtonBodyGetFirstJoint, newton)
API(NewtonBodyGetNextJoint, newton)
API(NewtonBodyGetFirstContactJoint, newton)
API(NewtonBodyGetNextContactJoint, newton)

API(NewtonContactJointGetFirstContact, newton)
API(NewtonContactJointGetNextContact, newton)

API(NewtonContactJointGetContactCount, newton)
API(NewtonContactJointRemoveContact, newton)

API(NewtonContactGetMaterial, newton)
API(NewtonBodyAddBuoyancyForce, newton)

API(NewtonBodyAddImpulse, newton)

// **********************************************************************************************
//
// Common joint functions
//
// **********************************************************************************************
API(NewtonJointGetUserData, newton)
API(NewtonJointSetUserData, newton)

API(NewtonJointGetBody0, newton)
API(NewtonJointGetBody1, newton)

API(NewtonJointGetInfo, newton)
API(NewtonJointGetCollisionState, newton)
API(NewtonJointSetCollisionState, newton)

API(NewtonJointGetStiffness, newton)
API(NewtonJointSetStiffness, newton)

API(NewtonDestroyJoint, newton)
API(NewtonJointSetDestructor, newton)

// **********************************************************************************************
//
// Ball and Socket joint functions
//
// **********************************************************************************************
API(NewtonConstraintCreateBall, newton)
API(NewtonBallSetUserCallback, newton)
API(NewtonBallGetJointAngle, newton)
API(NewtonBallGetJointOmega, newton)
API(NewtonBallGetJointForce, newton)
API(NewtonBallSetConeLimits, newton)

// **********************************************************************************************
//
// Hinge joint functions
//
// **********************************************************************************************
API(NewtonConstraintCreateHinge, newton)

API(NewtonHingeSetUserCallback, newton)
API(NewtonHingeGetJointAngle, newton)
API(NewtonHingeGetJointOmega, newton)
API(NewtonHingeGetJointForce, newton)
API(NewtonHingeCalculateStopAlpha, newton)

// **********************************************************************************************
//
// Slider joint functions
//
// **********************************************************************************************
API(NewtonConstraintCreateSlider, newton)
API(NewtonSliderSetUserCallback, newton)
API(NewtonSliderGetJointPosit, newton)
API(NewtonSliderGetJointVeloc, newton)
API(NewtonSliderGetJointForce, newton)
API(NewtonSliderCalculateStopAccel, newton)

// **********************************************************************************************
//
// Corkscrew joint functions
//
// **********************************************************************************************
API(NewtonConstraintCreateCorkscrew, newton)
API(NewtonCorkscrewSetUserCallback, newton)
API(NewtonCorkscrewGetJointPosit, newton)
API(NewtonCorkscrewGetJointAngle, newton)
API(NewtonCorkscrewGetJointVeloc, newton)
API(NewtonCorkscrewGetJointOmega, newton)
API(NewtonCorkscrewGetJointForce, newton)

API(NewtonCorkscrewCalculateStopAlpha, newton)
API(NewtonCorkscrewCalculateStopAccel, newton)

// **********************************************************************************************
//
// Universal joint functions
//
// **********************************************************************************************
API(NewtonConstraintCreateUniversal, newton)
API(NewtonUniversalSetUserCallback, newton)
API(NewtonUniversalGetJointAngle0, newton)
API(NewtonUniversalGetJointAngle1, newton)
API(NewtonUniversalGetJointOmega0, newton)
API(NewtonUniversalGetJointOmega1, newton)
API(NewtonUniversalGetJointForce, newton)

API(NewtonUniversalCalculateStopAlpha0, newton)
API(NewtonUniversalCalculateStopAlpha1, newton)

// **********************************************************************************************
//
// Up vector joint functions
//
// **********************************************************************************************
API(NewtonConstraintCreateUpVector, newton)
API(NewtonUpVectorGetPin, newton)
API(NewtonUpVectorSetPin, newton)

// **********************************************************************************************
//
// User defined bilateral Joint
//
// **********************************************************************************************
API(NewtonConstraintCreateUserJoint, newton)
API(NewtonUserJointSetFeedbackCollectorCallback, newton)
API(NewtonUserJointAddLinearRow, newton)
API(NewtonUserJointAddAngularRow, newton)
API(NewtonUserJointAddGeneralRow, newton)

API(NewtonUserJointSetRowMinimumFriction, newton)
API(NewtonUserJointSetRowAcceleration, newton)
API(NewtonUserJointSetRowAcceleration, newton)
API(NewtonUserJointSetRowSpringDamperAcceleration, newton)
API(NewtonUserJointSetRowStiffness, newton)
API(NewtonUserJointGetRowForce, newton)

// **********************************************************************************************
//
// Mesh joint functions
//
// **********************************************************************************************
API(NewtonMeshCreate, newton)
API(NewtonMeshCreateFromCollision, newton)
API(NewtonMeshDestroy, newton)

API(NewtonMeshCalculateVertexNormals, newton)
API(NewtonMeshApplySphericalMapping, newton)
API(NewtonMeshApplyBoxMapping, newton)
API(NewtonMeshApplyCylindricalMapping, newton)

API(NewtonMeshPlaneClip, newton)

API(NewtonMeshBeginFace, newton)
API(NewtonMeshAddFace, newton)
API(NewtonMeshEndFace, newton)


API(NewtonMeshGetVertexCount, newton)
API(NewtonMeshGetVertexStreams, newton)
API(NewtonMeshGetIndirectVertexStreams, newton)

API(NewtonMeshFirstMaterial, newton)
API(NewtonMeshNextMaterial, newton)
API(NewtonMeshMaterialGetMaterial, newton)
API(NewtonMeshMaterialGetIndexCount, newton)
API(NewtonMeshMaterialGetIndexStream, newton)
API(NewtonMeshMaterialGetIndexStreamShort, newton)
