#define PRAGMA_PATH "include"
#define PRAGMA_PATH "levels"

//#define PRAGMA_PLUGIN "newton.dll"; 

#define PRAGMA_TEXT "Newton Wrapper by VeTaL"

// newton works with meters!
// 1 meter = 32 quants
float QUANTTOMETER = 0.03125;
float METERTOQUANT = 32;

#include <acknex.h>
#include <default.c>
#include <d3d9.h>

#include "NewtonMain2.17.c"
#include "NewtonAPI2.17.c"

NewtonWorld* nworld;

var PressedR=0;
var PressedF=0;
var PressedM=0;
var PressedP=0;
var PressedSpace=0;
var PressedUp=0;
var PressedDn=0;

var map20_ents=800;


#include "matrix.c"
#include "newton_materials.c"
#include "newton_main.c"
#include "newton_debug.c"
#include "newton_power_mouse.c"
#include "newton_explosions.c"
#include "newton_compound.c"
#include "newton_particles.c"

#include "map10.c"
#include "map11.c"
#include "map12.c"
#include "map13.c"
#include "map14.c"
#include "map15.c"
#include "map16.c"
#include "map17.c"
#include "map18.c"
#include "map19.c"
#include "map20.c"
#include "map21.c"

//#include "menu.c"


//#define PRAGMA_PATH "!extend"
#include "map50.c"

action newt_wall()
{
	my.push=100;
	set(my,FLAG8);
	reset(my,DYNAMIC);
	wait(1);
	c_setminmax(me); 
}

//--------------------------------------------------------------------------------------- quit()
// gets called when the engine closes
//---------------------------------------------------------------------------------------
void quit()
{
	newton_stop();
}

//--------------------------------------------------------------------------------------- load_level(num)
// loads needed level
//---------------------------------------------------------------------------------------
int selected_level=1;
int now_level=1;

void load_level(num)
{	
//	wait(1);
	newton_stop();
	switch(num)
	{
		case 0:
		level_load("map10.wmb");
		now_level=0;
		break;
		case 1:
		level_load("map11.wmb");
		now_level=1;
		break;
		case 2:
		level_load("map12.wmb");
		now_level=2;
		break;
		case 3:
		level_load("map13.wmb");
		now_level=3;
		break;
		case 4:
		level_load("map14.wmb");
		now_level=4;
		break;
		case 5:
		level_load("map15.wmb");
		now_level=5;
		break;
		case 6:
		level_load("map16.wmb");
		now_level=6;
		break;
		case 7:
		level_load("map17.wmb");
		now_level=7;
		break;
		case 8:
		level_load("map18.wmb");
		now_level=8;
		break;
		case 9:
		level_load("map19.wmb");
		now_level=9;
		break;
		case 10:
		level_load("map20.wmb");
		now_level=10;
		break;
		case 11:
		level_load("map21.wmb");
		now_level=11;
		break;
		case 12:
		level_load("map50.wmb");
		now_level=12;
		break;
	}
	
	wait(1);
	newton_start();
}

TEXT* levelnamesstrings =
{
	string = 
	"1: Simple bodies", 
	"2: Restitution demo", 
	"3: Friction demo", 
	"4: Cone demo", 
	"5: Scale demo", 
	"6: Grabbing demo", 
	"7: Step-by-step creating",
	"8: Explosions",
	"9: Collisions",
	"10: Power mouse",
	"11: Crash test",
	"12: Impulse weapon demo",
	"13: Compound collition demo";
	//	flags = NARROW | TRANSLUCENT | TRANSPARENT;
}

TEXT* levelwhattodosstrings =
{
	string = 
	"1: Here you can see different types of bodies(sphere, box, 
	cone, capsule, chamfered cylinder, rock and tire), they are 
	falling down on the entity and on the terrain.
	You can use mouse roll or R/F to select levels and Enter
	to load it", 
	"2: Number of spheres with different elasticy, they
	are bouncing in different way.", 
	"3: Number of boxes with different friction.", 
	"4: Some rotating cones, this demo shows high quality of 
	Newton physics: cones dont fall because of angular speed.", 
	"5: Different scale factors.", 
	"6: Here you can pick up objects with the help of E key and
	throw them with left mouse button. Power of throwing depends 
	on how long you hold mouse", 
	"7: Step-by-step creating of rotating sphere, look source code
	for details: every step of creation is commented",
	"8: Explosions: you just drop some bombs(with the help of left 
	mouse button) down and watch, what happens next",
	"9: This one shows you two methods of creation ststic bodies",
	"10: Power mouse: just press space to turn it on. After that 
	you would be able to drug boxes with left mouse button. 
	Better wait a little for stabilizing blocks.",
	"11: This crash test just loads a lot of models. Number could 
	be changed in the script. Not recommdended to turn debug on F12",
	"12: Impulse weapon demo, you can shoot with impulse on the 
	entities. Note that they are bouncing in right direction.",
	"13: Compound collision demo. This scene shows the main idea of 
	compounds: you can make different shape from primitives and 
	combine them in the large structure";
	//	flags = NARROW | TRANSLUCENT | TRANSPARENT;
}

//--------------------------------------------------------------------------------------- main()
// main function
//---------------------------------------------------------------------------------------









void main()
{
	vec_set(&sky_color, nullvector);
	max_particles = 50000; // for draw_line3d()
	fps_max = 120;
	video_mode = 8;
	video_screen = 1;
	
	sky_color.red = 250;
	sky_color.green = 150;
	sky_color.blue = 50;
	
	sun_light = 50;
	sun_angle.tilt = 35;
	
	
	//level_load("");
	load_level(0);
	//level_load("map10.wmb");
	
	// 10 - simple bodies with model/terrain
	// 11 - restitution demo
	// 12 - friction demo
	// 13 - cone demo
	// 14 - scale demo
	// 15 - grab demo
	// 16 - step-by-step creating
	// 17 - explosions
	// 18 - collisions
	// 19 - power mouse
	// 20 - crash-test
	
	// 50 - compounds
	
	on_exit = quit;		
	def_moveset(); // default camera movement
	
	while(1)
	{
		selected_level = cycle(selected_level + mickey.z / 120, 1,12);
		draw_text((levelnamesstrings.pstring)[selected_level - 1], 8, 15, vector(255,255,255));
		draw_text((levelwhattodosstrings.pstring)[now_level], 500, 45, vector(255,255,255));
		
		
		newton_update();
		
		if ((key_p) && (!PressedP))	{newton_running = (newton_running == 0);  	PressedP=1;	}
		if (!key_p) {PressedP=0;}
		
		if ((key_m) && (!PressedM))	{AutoSleep();	PressedM=1;	}
		if (!key_m) {PressedM=0;}
		
		// level controls		
		if ((key_r) && (!PressedR))	{selected_level+=1;  	PressedR=1;	}
		if (!key_r) {PressedR=0;}
		
		if ((key_f) && (!PressedF))	{selected_level-=1;  	PressedF=1;	}
		if (!key_f) {PressedF=0;}		
		
	//	if (key_e) { load_level(selected_level-1);}
		if (key_enter) { load_level(selected_level-1);}
		
		wait(1);
	}
}

PANEL* first_pan=
{
//	digits (350, 10, "sleep_mode(changed by M): %1.0f", *, 1, sleep_mode);	
//	digits (350, 30, "debug_screen(changed by F12): %1.0f", *, 1, newtondebugdisplaymode);
	
	//digits (350, 100, "0: %1.0f", *, 1, selected_level);
	//digits (350, 130, "1: %1.0f", *, 1, diff_pan_vec.[1]);
	//digits (350, 160, "2: %1.0f", *, 1, diff_pan_vec.[2]);
	
	flags = VISIBLE;
}