var CompoundNumber = 5;
var CompoundPartsNumber = 3;
var CompN = 1;
var CompP = 1;
ENTITY* CompMainEnt = NULL;
ENTITY* CompOriginEnt = NULL;

NewtonCollision* compound[5];
NewtonCollision* compoundParts[10];

#define sDiffR				skill15
#define sDiffT				skill14
#define sDiffP				skill13

#define sDiffZ				skill12
#define sDiffY				skill11
#define sDiffX				skill10

function AddToCompound(int comp, ENTITY* ent, ENTITY* CompOriginEnt, float mass, int part, int total_parts)
{
	if (part==0)
	{ 
		CompMainEnt=ent;
		compoundParts[0] = newton_addcollision(me, nullvector);
	}
	else
	{
		my.sDiffX =my.x - CompMainEnt.x;
		my.sDiffY =my.y - CompMainEnt.y;
		my.sDiffZ =my.z - CompMainEnt.z;
		my.sDiffP = CompMainEnt.pan;
		my.sDiffT = CompMainEnt.tilt;
		my.sDiffR = CompMainEnt.roll;
		compoundParts[part] = newton_addcollision(me, vector(my.sDiffX,my.sDiffY,my.sDiffZ));
	}
	
	if (part==0) 
	{
		wait(1);
		
		NewtonCollision* collision = NewtonCreateCompoundCollision (nworld, total_parts, compoundParts);
		int i;
		for (i = 0; i < total_parts; i++) { NewtonReleaseCollision (nworld, compoundParts[i]);	}
		
		NewtonBody* body = NewtonCreateBody(nworld, collision);
		float m[16]; ent_getmatrix_rb(CompOriginEnt, m);
		NewtonBodySetMatrix(body, m);
		
		CompOriginEnt.skill99 = body; 
		NewtonBodySetUserData(body, CompOriginEnt); 
		
		NewtonBodySetTransformCallback(body, onsettransform);
		NewtonBodySetDestructorCallback(body, onsetdestructor);
		
		NewtonBodySetForceAndTorqueCallback(body, onforceandtorque);
		
		float inertia[3];
		float centerofmass[3];
		NewtonConvexCollisionCalculateInertialMatrix(collision, inertia, centerofmass); 
		NewtonBodySetMassMatrix(body, mass, mass * inertia[0], mass * inertia[1], mass * inertia[2]);
		
		NewtonReleaseCollision(nworld, collision);
	}	
}


action Compound_pt2()
{
	set(my,INVISIBLE);
	wait(3);
	AddToCompound(1,me,CompOriginEnt,75,0,2);
}


action Compound_pt1()
{
	set(my,INVISIBLE);
	CompMainEnt=me;
	wait(3);
	AddToCompound(1,me,CompOriginEnt,75,1,2);
}

action Compound_original()
{
	CompOriginEnt=me;
	wait(3);
}
