NewtonCollision *newton_addcollision(ENTITY* entity, VECTOR* diff)
{
	if(!entity) return;
	
	NewtonCollision* collision;
	
	int vertices = ent_vertices(entity);
	float *vertexcloud = (float*)malloc(sizeof(float) * vertices * 3);
	
	int i;
	for(i = 0; i < vertices; i++)
	{
		VECTOR vertex; vec_for_mesh(&vertex, entity, i + 1);
		vertexcloud[i * 3 + 0] = diff.x * QUANTTOMETER + (vertex.x) * entity->scale_x * QUANTTOMETER;
		vertexcloud[i * 3 + 1] = diff.y * QUANTTOMETER + (vertex.y) * entity->scale_y * QUANTTOMETER;
		vertexcloud[i * 3 + 2] = diff.z * QUANTTOMETER + (vertex.z) * entity->scale_z * QUANTTOMETER;
	}
	
	collision = NewtonCreateConvexHull(nworld, vertices, vertexcloud, 12, 0.01, NULL);
	free(vertexcloud);
	
	return collision;
}