// this callback is called for every contact between the two bodies
void ShowContacts (const NewtonJoint* contactJoint);

void GenericContactProcess (const NewtonJoint* contactJoint, dFloat timestep, int threadIndex)
{
	ShowContacts (contactJoint);
}





int defaultID;
int dynamicID;
int magnetID;

function newton_materials_init()
{
	defaultID = NewtonMaterialGetDefaultGroupID (nworld);
	dynamicID	= NewtonMaterialCreateGroupID (nworld);
	magnetID = NewtonMaterialCreateGroupID (nworld);

	// set default material properties
	NewtonMaterialSetDefaultCollidable (nworld, defaultID, defaultID, (float)1);
	NewtonMaterialSetDefaultSoftness (nworld, defaultID, defaultID, (float)0.05);
	NewtonMaterialSetDefaultElasticity (nworld, defaultID, defaultID, (float)0.4);	
	NewtonMaterialSetDefaultFriction (nworld, defaultID, defaultID, (float)1.0, (float)0.5);

	NewtonMaterialSetSurfaceThickness(nworld, defaultID, defaultID, (float)0.0);
}