BMAP* fx_bullet_explosion_bmap = "fire4_red.tga";

void fx_bullet_explosion_fade(PARTICLE* p)
{
	p.alpha -= 10 * time_step;
	if (p.alpha < 0) {p.alpha = 0; p.lifespan = 0;}
}

void fx_bullet_explosion(PARTICLE* p)
{
	p.blue = 128;
	p.green = 128;
	p.red = 128;
	p.bmap = fx_bullet_explosion_bmap;
	p.vel_x = (random(2) + random(2)) - 1.100;
	p.vel_y = (random(2) + random(2)) - 1.100;
	p.vel_z = random(2) + random(2);
	p.size = 4;
	p.alpha = 50;
	p.gravity = random(0.150);
	set(p,BEAM | MOVE | TRANSLUCENT | BRIGHT);
	p.event = fx_bullet_explosion_fade;
}
















BMAP* flame_particle = "flame.tga";

var ScaleFactor = 3;

var start_color[3];	
var end_color[3];		
var current_color[3];

var flame_lifespan = 22;


function flame_randomize (var* vec, var range)
{	
   vec[0] = random(1) - 0.5;
   vec[1] = random(1) - 0.5;
   vec[2] = random(1) - 0.5;
   vec_normalize(vec,random(range * ScaleFactor));
}

function flame_alphafade(PARTICLE *p)
{
	start_color[0] = 200;
	start_color[1] = 180;
	start_color[2] = 100;
	
	end_color[0] = 128;
	end_color[1] = 50;
	end_color[2] = 50;
	
	vec_lerp(current_color[0], end_color[0], start_color[0], p.lifespan / flame_lifespan);

	p.red = current_color[0];
	p.green = current_color[1];
	p.blue = current_color[2];
	
	p.alpha = p.lifespan / flame_lifespan * 100 * 0.3;
	if (p.alpha <= 0) p.lifespan = 0;
}

function effect_flame(PARTICLE *p)
{
   var temp[3];
   flame_randomize(temp, 1.3);
   vec_add (p.vel_x, temp);
   p.bmap = flame_particle;
   p.flags |= (BRIGHT | MOVE | TRANSLUCENT);
   p.lifespan = flame_lifespan;
   p.size = 12 * ScaleFactor;
   p.event = flame_alphafade; 
}